/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 1 "dscrinststat-cl.opt"
/* This file is part of Eclat.
   Copyright (C) 2012 Sergey Poznyakoff.
 
   Eclat is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.
 
   Eclat is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with Eclat.  If not, see <http://www.gnu.org/licenses/>. */

#line 30 "dscrinststat-cl.opt"

#line 30

#line 30
#ifdef HAVE_CONFIG_H
#line 30
# include <config.h>
#line 30
#endif
#line 30
#ifdef HAVE_GETOPT_H
#line 30
# include <getopt.h>
#line 30
#endif
#line 30
#include <unistd.h>
#line 30

#line 30
#include <grecs.h>
#line 30
#include <grecsopt.h>
#line 30
/* Option codes */
#line 30
enum {
#line 30
	_OPTION_INIT=255,
#line 30
	
#line 30
	MAX_OPTION
#line 30
};
#line 30
#ifdef HAVE_GETOPT_LONG
#line 30
static struct option long_options[] = {
#line 30
	#line 24 "dscrinststat-cl.opt"

#line 24
	{ "all", no_argument, 0, 'a' },
#line 30 "dscrinststat-cl.opt"

#line 30
	{ "help", no_argument, 0, 'h' },

#line 30 "dscrinststat-cl.opt"
	{0, 0, 0, 0}
#line 30
};
#line 30
#endif
#line 30
static struct grecs_opthelp opthelp[] = {
#line 30
	#line 26 "dscrinststat-cl.opt"

#line 26
	{
#line 26
#ifdef HAVE_GETOPT_LONG
#line 26
	  "-a, --all",
#line 26
#else
#line 26
	  "-a",
#line 26
#endif
#line 26
				   NULL, 0, N_("return the health status for all instances") },
#line 30 "dscrinststat-cl.opt"

#line 30
	{ NULL, NULL, 0, N_("Other options") },
#line 30 "dscrinststat-cl.opt"

#line 30
	{
#line 30
#ifdef HAVE_GETOPT_LONG
#line 30
	  "-h, --help",
#line 30
#else
#line 30
	  "-h",
#line 30
#endif
#line 30
				   NULL, 0, N_("Give this help list") },

#line 30 "dscrinststat-cl.opt"
};
#line 17 "dscrinststat-cl.opt"

#line 17

#line 17
static struct grecs_proginfo proginfo = {
#line 17
	"eclat describe-instance-status", /* progname */
#line 17
	N_("describe the status of Amazon EC2 instances including any scheduled events"), /* docstring */
#line 17
	N_("[FILTER...]"), /* args_doc */
#line 17
	opthelp, /* opthelp */
#line 17
	sizeof(opthelp)/sizeof(opthelp[0]), /* optcount */
#line 17
	NULL, /* print_help_hook */
#line 17
	NULL, /* print_version_hook */
#line 17
	PACKAGE_NAME,    /* package */
#line 17
	PACKAGE_VERSION, /* version */
#line 17
	NULL, /* license */
#line 17
NULL,/* copyright_year */
#line 17
NULL, /* copyright_holder */
#line 17
	NULL, /* *authors */
#line 17
	"<" PACKAGE_BUGREPORT ">", /* bug_address */
#line 17
	PACKAGE_URL, /* url */
#line 17
	NULL  /* epilogue */
#line 17
};
#line 17
static struct grecs_node *cmdline_tree;
#line 17

#line 30 "dscrinststat-cl.opt"

#line 30


static void
parse_options(int argc, char *argv[], int *index)
{
	static char *event_codes[] = {
		"instance-reboot",
		"system-reboot",
		"system-maintenance",
		"instance-retirement",
		NULL
	};
	static char *instance_state_name[] = {
		"pending",
		"running",
		"shutting-down",
		"terminated",
		"stopping",
		"stopped",
		NULL
	};
	static char *instance_state_code[] = {
		"0 (pending)",
		"16 (running)",
		"32 (shutting-down)",
		"48 (terminated)",
		"64 (stopping)",
		"80 (stopped)"
	};
	static char *system_status[] = {
		"ok",
		"impaired",
		"initializing",
		"insufficient-data",
		"not-applicable",
		NULL
	};
	static char *system_reachability[] = {
		"passed",
		"failed",
		"initializing",
		"insufficient-data",
		NULL
	};
	static char *instance_status[] = {
		"ok",
		"impaired",
		"initializing",
		"insufficient-data",
		"not-applicable"
	};
	static char *instance_reachability[] = {
		"passed",
		"failed",
		"initializing",
		"insufficient-data",
		NULL
	};
	static struct filter_descr filters[] = {
		{ "availability-zone",   FILTER_STRING },
		{ "event.code",          FILTER_ENUM, event_codes },
		{ "event.description",   FILTER_STRING },
		{ "event.not-after",     FILTER_DATE },
		{ "instance-state-name", FILTER_ENUM, instance_state_name },
		{ "instance-state-code", FILTER_ENUM, instance_state_code },
		{ "system-status.status",FILTER_ENUM, system_status },
		{ "system-status.reachability",
		                         FILTER_ENUM, system_reachability },
		{ "instance-status.status",
		                         FILTER_ENUM, instance_status },
		{ "instance-status.reachability",
		                         FILTER_ENUM, instance_reachability },
		{ NULL }
	};
	available_filters = filters;
	proginfo.print_help_hook = list_filters;
	
#line 106
 {
#line 106
  int c;
#line 106

#line 106
  optind = 0;
#line 106
#ifdef HAVE_GETOPT_LONG
#line 106
  while ((c = getopt_long(argc, argv, "ah",
#line 106
			  long_options, NULL)) != EOF)
#line 106
#else
#line 106
  while ((c = getopt(argc, argv, "ah")) != EOF)
#line 106
#endif
#line 106
    {
#line 106
      switch (c)
#line 106
	{
#line 106
	default:
#line 106
	   exit(EX_USAGE);	   exit(EX_USAGE);
#line 106
	#line 26 "dscrinststat-cl.opt"
	 case 'a':
#line 26
	  {
#line 26

	all_option = 1;

#line 28
	     break;
#line 28
	  }
#line 30 "dscrinststat-cl.opt"
	 case 'h':
#line 30
	  {
#line 30

#line 30
		grecs_print_help(&proginfo);
#line 30
		exit(0);
#line 30
	 
#line 30
	     break;
#line 30
	  }

#line 106 "dscrinststat-cl.opt"
	}
#line 106
    }
#line 106
  *index = optind;
#line 106
  if (cmdline_tree)
#line 106
    {
#line 106
      struct grecs_node *rn = grecs_node_create(grecs_node_root, NULL);
#line 106
      rn->down = cmdline_tree;
#line 106
      cmdline_tree = rn;
#line 106
    }
#line 106
 }
#line 106

}
